<?xml version="1.0" encoding="UTF-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="html"/>

	<xsl:template match="/">
		
			<html>
        <head>
          <script language="javascript">
            function viewSection(sectionId)
            {
            if(document.getElementById(sectionId).style.display == 'none')
            { document.getElementById(sectionId).style.display = 'inline'; }
            else
            { document.getElementById(sectionId).style.display = 'none'; }
            }
          </script>
          <style type="text/css">
            .checkTypeLabel
            {
            font: italic normal 2.0em georgia, sans-serif;
            color: #7D775C;
            letter-spacing: 1px;

            }

            .checkType
            {

            }

            .check
            {
            font: italic normal 1.5em georgia, sans-serif;
            padding-left:45;
            }

            .checkDetail
            {

            padding-left:20;
            }

            .checkDetailItem
            {
            }

            .checkLabel
            {
            font-weight: bold;
            font: .65em;
            }
            .checkValue
            {
            font: .65em;
            margin-left: 15;
            }
          </style>
        </head>

				<body style="font-size: 77%; font-family: verdana, lucida, arial, helvetica, sans-serif;">

          <H2>
            Check set: '<xsl:value-of select="checkSet/@name"/>'
          </H2>
          <br/>

          <xsl:apply-templates select="checkSet"/>

				</body>
			</html>

	</xsl:template>

  <xsl:template match="checkSet">


      <xsl:for-each select="check[not(@checkType = preceding-sibling::check/@checkType)]">
        <xsl:sort select="check/@checkType"/>
        <xsl:variable name="checkType" select="@checkType" />
        <div class="checkType">
          
          <img src="{concat(/checkSet/@applicationPath, '/XSLT/images/', $checkType, '.gif')}" />
          <span class="checkTypeLabel">
            <xsl:value-of select="$checkType"/>
          </span>
          
          <xsl:for-each select="/checkSet/check[@checkType=$checkType]">
            <div class="check">
              <xsl:value-of select="position()"/>:
              <xsl:apply-templates select="." mode="All" />
            </div>
          </xsl:for-each>
        </div>   
        
      </xsl:for-each>
      
    
  </xsl:template>

  <xsl:template match="check" mode="All">
    
    <a>
      <xsl:attribute name="href">javascript:viewSection('check_<xsl:value-of select="count(preceding-sibling::*)" />');</xsl:attribute>
      <xsl:value-of select="@name"/>
    </a>
    <div class="checkDetail" style="display:none" id="{concat('check_', count(preceding-sibling::*))}">

      <xsl:choose>
        <xsl:when test="@checkType = 'GAC'">
          <xsl:apply-templates select="." mode="GAC" />
        </xsl:when>
        <xsl:when test="@checkType = 'SQL'">
          <xsl:apply-templates select="." mode="SQL" />
        </xsl:when>
        <xsl:when test="@checkType = 'Registry'">
          <xsl:apply-templates select="." mode="Registry" />
        </xsl:when>
        <xsl:when test="@checkType = 'File' or @checkType = 'configurationFile' ">
          <xsl:apply-templates select="." mode="File" />
        </xsl:when>
        <xsl:when test="@checkType = 'Directory'">
          <xsl:apply-templates select="." mode="Directory" />
        </xsl:when>
        <xsl:when test="@checkType = 'FileSystemSecurity'">
          <xsl:apply-templates select="." mode="FileSystemSecurity" />
        </xsl:when>
        <xsl:when test="@checkType = 'Ping'">
          <xsl:apply-templates select="." mode="Ping" />
        </xsl:when>
      </xsl:choose>
    </div>
  </xsl:template>

  <xsl:template match="check" mode="Directory">
    <div class="checkDetailItem">
      <span class="checkLabel">Directory Name:</span>
      <span class="checkValue">
        <xsl:value-of select="@directoryName"/>
      </span>
    </div>
  </xsl:template>


  <xsl:template match="check" mode="Ping">
    <div class="checkDetailItem">
      <span class="checkLabel">Ping Target:</span>
      <span class="checkValue">
        <xsl:value-of select="@pingTarget"/>
      </span>
    </div>
  </xsl:template>


  <xsl:template match="check" mode="FileSystemSecurity">
    <div class="checkDetailItem">
      <span class="checkLabel">File System Name:</span>
      <span class="checkValue">
        <xsl:value-of select="@fileSystemName"/>
      </span>
    </div>
    <div class="checkDetailItem">
      <span class="checkLabel">Object Name:</span>
      <span class="checkValue">
        <xsl:value-of select="@objectName"/>
      </span>
    </div>

    <div class="checkDetailItem">
      <span class="checkLabel">File or Directory:</span>
      <span class="checkValue">
        <xsl:value-of select="@fileOrDirectory"/>
      </span>
    </div>

    <div class="checkDetailItem">
      <span class="checkLabel">Access Permission:</span>
      <span class="checkValue">
        <xsl:value-of select="@accessPermission"/>
      </span>
    </div>
  </xsl:template>

  <xsl:template match="check" mode="GAC">
    <div class="checkDetailItem">
      <span class="checkLabel">Component Name:</span>
      <span class="checkValue">
        <xsl:value-of select="@componentName"/>
      </span>
    </div>

    <div class="checkDetailItem">
      <span class="checkLabel">
        Version Number:
      </span>
      <span class="checkValue">
        <xsl:value-of select="@versionNumber"/>
      </span>
    </div>
  </xsl:template>

  <xsl:template match="check" mode="Registry">
    <div class="checkDetailItem">
      <span class="checkLabel">
        Hive path:
      </span>
      <span class="checkValue">
        <xsl:value-of select="@hivePath"/>
      </span>
    </div>
    <div class="checkDetailItem">
      <span class="checkLabel">
        Hive name:
      </span>
      <span class="checkValue">
        <xsl:value-of select="@hiveName"/>
      </span>
    </div>
    <div class="checkDetailItem">
      <span class="checkLabel">
        Hive value:
      </span>
      <span class="checkValue">
        <xsl:value-of select="@hiveValue"/>
      </span>
    </div>
          
  </xsl:template>

  <xsl:template match="check" mode="SQL">
    <div class="checkDetailItem">
      <span class="checkLabel">
        Server Instance:
      </span>
      <span class="checkValue">
        <xsl:value-of select="@serverInstance"/>
      </span>
    </div>
    <div class="checkDetailItem">
      <span class="checkLabel">
        Database Name:
      </span>
      <span class="checkValue">
        <xsl:value-of select="@databaseName"/>
      </span>
    </div>
    <div class="checkDetailItem">
      <span class="checkLabel">
        Table count:
      </span>
      <span class="checkValue">
        <xsl:value-of select="@tableCount"/>
      </span>
    </div>
    <div class="checkDetailItem">
      <span class="checkLabel">
        Stored Procedure count:
      </span>
      <span class="checkValue">
        <xsl:value-of select="@storedProcedureCount"/>
      </span>
    </div>
    <div class="checkDetailItem">
      <span class="checkLabel">
        View count:
      </span>
      <span class="checkValue">
        <xsl:value-of select="@viewCount"/>
      </span>
    </div>
  </xsl:template>

  <xsl:template match="check" mode="File">
    <div class="checkDetailItem">
      <span class="checkLabel">
        File Name:
      </span>
      <span class="checkValue">
        <xsl:value-of select="@fileName"/>
      </span>
    </div>
    <div class="checkDetailItem">
      <span class="checkLabel">
        File Version:
      </span>
      <span class="checkValue">
        <xsl:value-of select="@fileVersion"/>
      </span>
    </div>
    
  </xsl:template>
      
</xsl:stylesheet>